#region usings
using System;
using System.ComponentModel.Composition;

using VVVV.PluginInterfaces.V1;
using VVVV.PluginInterfaces.V2;
using VVVV.Utils.VColor;
using VVVV.Utils.VMath;

using VVVV.Core.Logging;

using System.Reflection;
using System.Text;
using System.Globalization;

#endregion usings

namespace VVVV.Nodes
{
	#region PluginInfo
	[PluginInfo(Name = "RemoveDiacritic", Category = "String", Version = "1.0", Help = "Basic template with one string in/out", Tags = "")]
	#endregion PluginInfo
	public class C1_0StringRemoveDiacriticNode : IPluginEvaluate
	{
		#region fields & pins
		[Input("Input", DefaultString = "aàáâãäåçc")]
		public ISpread<string> FInput;

		[Output("Output")]
		public ISpread<string> FOutput;

		[Import()]
		public ILogger FLogger;
		
		#endregion fields & pins

		
		//Transforms the culture of a letter to its equivalent representation in the 0-127 ascii table, such as the letter 'é' is substituted by an 'e'
		public string RemoveDiacritics(string s)
			{
			string normalizedString = null;
			StringBuilder stringBuilder = new StringBuilder();
			normalizedString = s.Normalize(NormalizationForm.FormD);
			int i = 0;
			char c = '\0';
			
			for (i = 0; i <= normalizedString.Length - 1; i++)
				{
				c = normalizedString[i];
				if (CharUnicodeInfo.GetUnicodeCategory(c) != UnicodeCategory.NonSpacingMark)
				{
				    stringBuilder.Append(c);
				}
				}
			
			return stringBuilder.ToString();
			}
		
			
		//called when data for any output pin is requested
		public void Evaluate(int SpreadMax)
		{
			FOutput.SliceCount = SpreadMax;

			for (int i = 0; i < SpreadMax; i++)
				FOutput[i] = RemoveDiacritics(FInput[i]);

			//FLogger.Log(LogType.Debug, "Logging to Renderer (TTY)");
		}
	}
}
